
TYPO3.Flow - Bug # 29582

Status: Closed Priority: Must have
Author: Fernando Arconada Category: Property
Created: 2011-09-09 Assigned To: Karsten Dambekalns
Updated: 2012-03-15 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: FLOW3 1.0.0
Subject: you should be able to pass any kind of objects to action methods
Description

if you try to pass an object not related to persistence manager to an actionmethod you will get an exeption:
Uncaught Exception in FLOW3
#1302628242: The given object is unknown to the Persistence Manager

This this wrong, for example if you want to implement an exception handler that would be called by other method and not from a web
request. In general is wrong to think that all action will be called by a web request

History
#1 - 2011-09-09 21:41 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#2 - 2011-09-09 21:42 - Karsten Dambekalns
- Category set to Property
- Status changed from New to Needs Feedback
- Assigned To set to Karsten Dambekalns

Could you provide the signature of the action method and what kind of object you want to pass to it? Thanks!

#3 - 2011-09-09 22:03 - Fernando Arconada
class AbstractController extends ActionController {
    public function processRequest(\TYPO3\FLOW3\MVC\RequestInterface $request, \TYPO3\FLOW3\MVC\ResponseInterface $response) {
        try {
            parent::processRequest($request, $response);
        } catch (CustomException $exception) {
            $this->redirect('exceptionHandler','Standard',NULL,array('exception'=>$exception));
        }
    }
}

class StandardController extends AbstractController {
    /**
     * @param /Enterprise.CustomPackage/Exceptions/CustomException $exception
     * @return void
     */
    public function exceptionHandlerAction($exception) {
        $this->view->assign('exception',$exception);
    }
}

#4 - 2011-09-10 10:17 - Karsten Dambekalns

Fernando Arconada wrote:

param /Enterprise.CustomPackage/Exceptions/CustomException $exception

If that is really what you have there, try with backslashes and the real namespace (no dot, that is). I'll give it a look next week, though.

#5 - 2011-09-10 11:14 - Fernando Arconada

sorry, the slashes were ok in my code but not in the issue. Really, cause this issue is blocking me i had to pass only the exception message (string) as
a parameter to continue coding

#6 - 2011-09-12 11:31 - Bastian Waidelich

Fernando Arconada wrote:

sorry, the slashes were ok in my code but not in the issue.

I'm pretty sure I have successfully used arbitrary objects as action parameters.
Your code should look like this:

class StandardController extends AbstractController {

    /**
     * @param \Enterprise\CustomPackage\Exceptions\CustomException $exception
     * @return void
     */
    public function exceptionHandlerAction(\Enterprise\CustomPackage\Exceptions\CustomException $exception) {
        $this->view->assign('exception',$exception);
    }
}

HTH

#7 - 2011-09-12 18:30 - Fernando Arconada

     /**
     * @param \F2\SLists\Exception\SListsException $exception
     * @return void
     */
    public function exceptionHandlerAction(\F2\SLists\Exception\SListsException $exception){
        $this->view->assign('exception',$exception);
    }

and it doesnt works

I fired and UserException that extends SListsException

#8 - 2011-10-21 13:20 - Karsten Dambekalns
- Affected Flow version set to FLOW3 1.0.0

#9 - 2012-03-14 15:39 - Christian Müller
- Has patch set to No

The interesting question is, how is this being called?

#10 - 2012-03-14 19:33 - Fernando Arconada

seems easier in java, in php may be with apc then if it is attached to apc is not a good idea to have inside the framework and you should cose the
ticket

#11 - 2012-03-15 07:35 - Christian Müller
- Status changed from Needs Feedback to Closed
